HC = require 'HardonCollider'
loader = require "AdvTiledLoader/Loader"
TLbind = love.filesystem.load("TLbind_custom.lua")
camera = require 'hump.camera'
vector = require 'hump.vector'
require 'functions.lua'
require 'player.lua'
require 'zombie.lua'
require 'game.lua'
loader.path = "maps/"

function love.load()
    cam = camera(vector(200,150),1.5)
    player = {}
    player.controls = "keyboard"
    gamestate = "intro"
    introscreen = love.graphics.newImage("front.jpg")
    game_load()
    player.controlOptions, player.control = makeJoystickControls(0)
end

function love.update(dt)
    player.controlOptions:update()
    if love.keyboard.isDown("f1") and gamestate == "intro" or player.control["start"] and gamestate == "intro" then 
        game_load()
        gamestate = "game"
    end
    if gamestate == "game" then 
        game_update(dt)
    end
end

function love.draw()
    if gamestate == "intro" then
        love.graphics.draw(introscreen, 0,0)
    end
    if gamestate == "game" then 
        game_draw()
    end
end

function makeJoystickControls(index)
    local controlOptions, control = TLbind()
    controlOptions.useKeyboard = false
    controlOptions.useJoystick = true
    controlOptions.deadzone = 0
    controlOptions.joyAxes = { [index]={
        [0] = "Hori",
        [1] = "Vert",
        [3] = "VerAim",
        [4] = "HorAim"
    }}
    controlOptions.joyBtns = { [index]={
        [5] = "fire",
        [7] = "start",
        [4] = "sprint",
        [6] = "select"
    }}
    return controlOptions, control
end