function player_update(dt)
    if love.keyboard.isDown("a")
    and love.keyboard.isDown("w")
    or love.keyboard.isDown("a")
    and love.keyboard.isDown("s")
    or love.keyboard.isDown("d")
    and love.keyboard.isDown("w")
    or love.keyboard.isDown("d")
    and love.keyboard.isDown("s") then 
        circ:move(speedx*dt,speedy*dt*0.7)
        emitterpos:move(speedx*dt,speedy*dt*0.7)
    else
        circ:move(speedx*dt,speedy*dt)
        emitterpos:move(speedx*dt,speedy*dt)
    end

    for j = #allSolidTiles, 1, -1 do
        local t = allSolidTiles[j]
        if circ:collidesWith(t) then
            local collbol, collmtv = circ:collidesWith(t)
            circ:move(collmtv.x, collmtv.y)
            emitterpos:move(collmtv.x, collmtv.y)
        end
    end
    target = cam:mousepos()
    x,y = target.x, target.y
    pos = cam:worldCoords(circ:center())
    xc,yc = circ:center()

    if player.controls == "keyboard" then
        circAngle = getAngle(x,y ,xc,yc)
        circ:setRotation(circAngle-math.pi)
    elseif player.controls == "gamepad" then
        if player.control["VerAim"] > 0.5 or player.control["HorAim"] > 0.5 or player.control["VerAim"] < -0.5 or player.control["HorAim"] < -0.5 then
            circ:setRotation(math.atan2(player.control["VerAim"], player.control["HorAim"]))
        end
    end

    xc,yc = circ:center()
    -- particle flash
    emitterpos:setRotation(circ:rotation(), xc, yc)
    xe, ye = emitterpos:center()
    flash:setPosition(xe, ye)
    flash:setDirection(emitterpos:rotation())
    
    if player.controls == "keyboard" then 
        player_move(dt)
    elseif player.controls == "gamepad" then
        if sprinting then
            speedx = player.control["Hori"]*150
            speedy = player.control["Vert"]*150
        else 
            speedx = player.control["Hori"]*100
            speedy = player.control["Vert"]*100
        end
    end

    if player.control.tap["select"]then 
        if player.controls == "keyboard" then 
            player.controls = "gamepad"
        elseif player.controls == "gamepad" then 
            player.controls = "keyboard"
        end 
    end

    player_shoot(dt)
end

function player_move(dt)
    if love.keyboard.isDown("a") then 
        if love.keyboard.isDown("lshift") and stamina > 1 or player.control["sprint"] and stamina > 1 then
            speedx = -150
        else
            speedx = -100
        end
    elseif love.keyboard.isDown("d") then 
        if love.keyboard.isDown("lshift") and stamina > 1 or player.control["sprint"] and stamina > 1 then
            speedx = 150
        else 
            speedx = 100
        end
    end
    if love.keyboard.isDown("w") then 
        if love.keyboard.isDown("lshift") and stamina > 1 or player.control["sprint"] and stamina > 1 then
            speedy = -150
        else 
            speedy = -100
        end
    elseif love.keyboard.isDown("s") then 
        if love.keyboard.isDown("lshift") and stamina > 1 or player.control["sprint"] and stamina > 1 then
            speedy = 150
        else 
            speedy = 100
        end
    end

    if not love.keyboard.isDown("a")
        and not love.keyboard.isDown("d") then 
        speedx = 0
    end 
    if not love.keyboard.isDown("w") 
        and not love.keyboard.isDown("s") then
        speedy = 0
    end
end

function player_shoot(dt)
    time2 = time2 + dt
    time = time + dt
    animtime2 = animtime2 + dt
    if love.mouse.isDown("l") or player.control["fire"] then
        if currwep == "smp" then
            --time = time + dt
            if time > 0.2 or first == true and time2 > 0.2 then
                first = false
                flash:start()
                shoot(x, y)
                time = 0
                time2 = 0
            end
        elseif currwep == "knife" then 
            handle_anim(dt)
        end
    elseif not love.mouse.isDown("l") or not player.control["fire"] then
        if currwep == "smp" then
            first = true
            flash:stop()
            time = 0
        elseif currwep == "knife" then 
            if animknife > 1 then 
                handle_anim(dt)
            end
        end
    end
    flash:update(dt)
end

function love.keypressed(key)
    if key == "f5" then 
        if player.controls == "keyboard" then 
            player.controls = "gamepad"
        elseif player.controls == "gamepad" then 
            player.controls = "keyboard"
        end 
    end

    if key == "1" then 
        currwep = "smp"
    end
    if key == "2" then 
        currwep = "knife"
    end
    if key == "z" then 
        x,y = love.mouse.getPosition()
        spawnzombie(x/scaleAmount,y/scaleAmount)
    end
end

function bullet_update(dt)
    for i = #bullets, 1, -1 do -- reverse-order trick
        local b = bullets[i]
        local bx, by = b:center()
        if bx < 0 or bx > gw or by < 0 or by > gh then
            table.remove(bullets, i)
            Collider:remove(b)
        else
            b:move(b.xvel * dt, b.yvel * dt)
            bx2, by2 = b:center()
        end
        for j = #allSolidTiles, 1, -1 do
            local t = allSolidTiles[j]
            if b:collidesWith(t) then 
                table.remove(bullets, i)
                Collider:remove(b)
            end 
        end
    end
end 