function zombie_update(dt)
    for i, z in ipairs(zombies) do
        zx,zy = z:center()
        xc,yc = circ:center()
        zombAngle = getAngle(zx,zy, xc,yc)
        --z:setRotation(zombAngle-math.pi)
        local dir = zombAngle
        z.xvel = math.cos(dir) * z.speed
        z.yvel = math.sin(dir) * z.speed
        z:move(z.xvel * dt, z.yvel * dt)

        if z:collidesWith(circ) then 
            local collbol, collmtv = z:collidesWith(circ)
            z:move(collmtv.x, collmtv.y)
            if sprinting then 
                z.speed = -200
                z.push = true
                health = health - 0.1
            else 
                health = health - 0.5
            end
        end
        
        if z.push == true then 
            z.time = z.time + dt 
            if z.time > 0.2 then 
                z.speed = 80
                z.push = false
                z.time = 0
            end
        end

        if z.health < 1 then 
            Collider:remove(z)
            table.remove(zombies, i)
            kills = kills + 1
            break
        end
--[[
        if #zombies > 1 then
            for b = #zombies, i+1, -1 do 
                local k = zombies[b]
                if z:collidesWith(k) and z.coltile == false then
                    local collbol, collmtv = z:collidesWith(k)
                    k:move(-collmtv.x, -collmtv.y)
                end
            end
        end
]]
        for i = #bullets, 1, -1 do
            local b = bullets[i]
            if b:collidesWith(z) then 
                z.health = z.health - 1
                table.remove(bullets, i)
                Collider:remove(b)
                break
            end 
        end

--[[
        --Collider:update(dt)

        for j = #allSolidTiles, 1, -1 do
            local t = allSolidTiles[j]
            if z:collidesWith(t) then
                local collbol, collmtv = z:collidesWith(t)
                z:move(collmtv.x, collmtv.y)
                z.coltile = true
            else 
                z.coltile = false
            end
        end
    ]]
    end
end

function spawnzombie(x, y)
    --local zombie = Collider:addRectangle(x, y, 10, 24)
    local zombie = Collider:addCircle(x,y, 11)
    zombie.type = "zombie"
    zombie.nr = #zombies+1
    zombie.speed = 80
    zombie.coltile = false
    zombie.push = false
    zombie.time = 0
    zombie.health = 3
    zombie.xvel = 0
    zombie.yvel = 0
    table.insert(zombies, zombie)
end

function collision_stop(dt, shape_a, shape_b)

end

function on_collision(dt, shape_a, shape_b, mtv_x, mtv_y)
    local zombie_shape, tileshape
    if shape_a.type == "zombie" and shape_b.type == "tile" or shape_a.type == "zombie" and shape_b.type == "zombie" then
        zombie_shape = shape_a
        zombie_shape:move(mtv_x, 0)
        zombie_shape:move(0, mtv_y)
    elseif shape_b.type == "zombie" and shape_a.type == "tile" or shape_b.type == "zombie" and shape_a.type == "zombie" then
        zombie_shape = shape_b
        zombie_shape:move(mtv_x, 0)
        zombie_shape:move(0, mtv_y)
    else 
        return
    end
end